<?php
/**
* 第三方平台 请求抽象类
*
* @category apibusiness
* @package apibusiness/lib/request/
* @author chenping<chenping@shopex.cn>
* @version $Id: partyabstract.php 2013-13-12 14:44Z
*/
abstract class apibusiness_request_partyabstract extends apibusiness_request_abstract
{
   /**
     * 添加支付单
     *
     * @param Array $delivery
     * @return void
     * @author
     **/
    public function add_delivery($delivery)
    {
        $rs = array('rsp'=>'fail','msg'=>'','data'=>'');
        if (!$delivery) {
            $rs['msg'] = 'no delivery';
            return $rs;
        }

        $deliOrderModel = app::get(self::_APP_NAME)->model('delivery_order');
        $orderModel = app::get(self::_APP_NAME)->model('orders');
        if ($delivery['is_bind'] == 'true') {
            $deliOrderList = $deliOrderModel->getList('*',array('delivery_id'=>$delivery['delivery_id']));
            if ($deliOrderList) {
                foreach ($deliOrderList as $key => $deliOrder) {
                    $order = $orderModel->dump(array('order_id'=>$deliOrder['order_id']),'ship_status,shop_id,order_bn,is_delivery,mark_text,sync,order_id,self_delivery,createway');

                    //ExBOY加入部分发货时也回写
                    if ($order['ship_status'] != '1' && $order['ship_status'] != '2') {
                        continue;
                    }
                    
                    if ($delivery['shop_id'] != $order['shop_id']) {
                        $mydelivery = $deliOrderModel->dump(array('order_id' => $deliOrder['order_id'],'delivery_id|noequal'=>$delivery['delivery_id']));
                        if ($mydelivery) {
                            kernel::single('ome_service_delivery')->delivery($mydelivery['delivery_id']);
                        }
                        continue;
                    }

                    $delivery['order'] = $order;

                    $this->delivery_request($delivery);
                }
            }
        } else {
            
            if( !isset($delivery['delivery_id']) ){
                $deliOrder['order_id'] = $delivery['order']['order_id'];
            }else{
                $deliOrder = $deliOrderModel->dump(array('delivery_id'=>$delivery['delivery_id']),'*');
            }
            
            $order = $orderModel->dump(array('order_id'=>$deliOrder['order_id']),'ship_status,order_bn,shop_id,is_delivery,mark_text,sync,order_id,self_delivery,createway');

            //ExBOY加入部分发货时也回写
            if ($order['ship_status'] != '1' && $order['ship_status'] != '2') {
                return false;
            }

            $delivery['order'] = $order;

            $this->delivery_request($delivery);
        }

        $rs['rsp'] = 'success';

        return $rs;
    }// TODO TEST


    /**
     * 更新售后状态
     * @param   type    $varname    description
     * @return  type    description
     * @access  public
     * @author cyyr24@sina.cn
     */
    function update_aftersale_status($aftersale,$status='' , $mod='async')
    {
        $orderModel = app::get(self::_APP_NAME)->model('orders');
        $order      = $orderModel->dump($aftersale['order_id'], 'order_bn');
        if (!$status) {
            $status = $aftersale['status'];
        }
        $api_method = $this->aftersale_api($status);
        
        if ($api_method == '') {
            return true;
        }
        $title = '店铺('.$this->_shop['name'].')更新[交易售后状态]:'.$status.',(订单号:'.$order['order_bn'].'退款单号:'.$aftersale['return_bn'].')';
        $params     = $this->format_aftersale_params($aftersale,$status);
        
        $params['tid'] = $order['order_bn'];
       
        $addon['bn'] = $order['order_bn'];
        $result = array();
        if ($mod == 'async') {
            $callback = array(
                'class' => get_class($this),
                'method' => 'update_aftersale_status_callback',
            );
            $result = $this->_caller->request($api_method,$params,$callback,$title,$this->_shop['shop_id'],10,false,$addon);
            
        }else{
            $timeout = 20;
            $shop_id = $this->_shop['shop_id'];
            $rsp = $this->_caller->call($api_method, $params, $shop_id, $timeout);
            
            //生成日志ID号
            $oApi_log = app::get(self::_APP_NAME)->model('api_log');
            $log_id = $oApi_log->gen_id();
            $callback = array(
                'class'   => get_class($this),
                'method'  => __METHOD__,
                '2'       => array(
                    'log_id'  => $log_id,
                    'shop_id' => $shop_id,
                ),
            );
            $oApi_log->write_log($log_id,$title,'apibusiness_router_request','refuse_return',array($api_method, $params, $callback),'','request','running','','','api.store.trade',$addon['bn']);
            if (!$rsp) return false;
            if($rsp->rsp == 'succ'){
                $api_status = 'success';
                $msg = '售后单状态更新成功<BR>';
                $oApi_log->update(array('msg_id'=>$rsp->msg_id,'msg'=>$msg,'status'=>$api_status),array('log_id'=>$log_id));
            }else{
                $api_status = 'fail';
                $err_msg = $rsp->err_msg ? $rsp->err_msg : $rsp->res;
                $msg = '售后单状态更新成功('.$err_msg.')<BR>';
                $oApi_log->update(array('msg_id'=>$rsp->msg_id,'msg'=>$msg,'status'=>$api_status),array('log_id'=>$log_id));
            }
            $result['rsp']     = $rsp->rsp;
            $result['err_msg'] = $rsp->err_msg;
            $result['msg_id']  = $rsp->msg_id;
            $result['res']     = $rsp->res;
            $result['data']    = json_decode($rsp->data,1);
        }
        if(isset($result['msg']) && $result['msg']){
            $rs['msg'] = $result['msg'];
        }elseif(isset($result['err_msg']) && $result['err_msg']){
            $rs['msg'] = $result['err_msg'];
        }elseif(isset($result['res']) && $result['res']){
            $rs['msg'] = $result['res'];
        }
        $rs['rsp'] = $result['rsp'];
        $rs['data'] = $result['data'];
        return $rs;
    }

    public function update_aftersale_status_callback($result)
    {
        return $this->_caller->callback($result);
    }

    protected function format_aftersale_params($refund,$status){}
    protected function aftersale_api($status){}

    /**
     * 更新退款单状态
     * @param   
     * @return array 
     * @access  public
     * @author cyyr24@sina.cn
     */
    function update_refund_apply_status($refund,$status,$mod = 'sync')
    {
        $orderModel = app::get(self::_APP_NAME)->model('orders');
        $order = $orderModel->dump($refund['order_id'], 'order_bn');

        $api_method = $this->refund_apply_api($status);
        if ($api_method == '') {
            return false;
        }
        $params     = $this->format_refund_applyParams($refund,$status);
        $params['tid'] = $order['order_bn'];
        $title = '店铺('.$this->_shop['name'].')更新[交易退款状态],(订单号:'.$order['order_bn'].'退款单号:'.$refundinfo['refund_apply_bn'].')';
        $addon['bn'] = $order['order_bn'];
        $shop_id = $this->_shop['shop_id'];
        $oApi_log = app::get(self::_APP_NAME)->model('api_log');
        $log_id = $oApi_log->gen_id();
        if ($mod == 'sync') {
            $timeout = 20;
            $rsp = $this->_caller->call($api_method, $params, $shop_id, $timeout);
            
            $callback = array(
                'class'   => get_class($this),
                'method'  => $api_method,
                '2'       => array(
                    'log_id'  => $log_id,
                    'shop_id' => $shop_id,
                ),
            );
            $oApi_log->write_log($log_id,$title,'apibusiness_router_request',$api_method,array($api_method, $params, $callback),'','request','running','','','api.store.trade',$addon['bn']);
            if ($rsp->rsp == 'succ') {
                $api_status = 'success';
                $msg = '退款申请单状态更新成功<br>';
                $oApi_log->update(array('msg_id'=>$rsp->msg_id,'msg'=>$msg,'status'=>$api_status),array('log_id'=>$log_id));
            }else{
                $api_status = 'fail';
                $err_msg = $rsp->err_msg ? $rsp->err_msg : $rsp->res;
                $msg = '退款申请单状态更新失败<br>';
                $oApi_log->update(array('msg_id'=>$rsp->msg_id,'msg'=>$msg,'status'=>$api_status),array('log_id'=>$log_id));
            }
            $result['rsp']     = $rsp->rsp;
            $result['err_msg'] = $rsp->err_msg;
            $result['msg_id']  = $rsp->msg_id;
            $result['res']     = $rsp->res;
            $result['data']    = json_decode($rsp->data,1);
        }
            
        if(isset($result['msg']) && $result['msg']){
            $rs['msg'] = $result['msg'];
        }elseif(isset($result['err_msg']) && $result['err_msg']){
            $rs['msg'] = $result['err_msg'];
        }elseif(isset($result['res']) && $result['res']){
            $rs['msg'] = $result['res'];
        }
        $rs['rsp'] = $result['rsp'];

        return $rs;
        
    }
    protected function format_refund_applyParams($refund,$status){
    }

    protected function refund_apply_api($status)
    {
    }
    
    public function searchAddress($rdef)
    {

        $shop_id = $this->_shop['shop_id'];
        
        $params = array(
            'search_type'=>$rdef,    
        );
        
        $callback = array(
            'class' => get_class($this),
            'method' => 'searchAddress_callback',
        );
        $title = '店铺('.$this->_shop['name'].')获取地址库列表';
        
        $addon=array();
        $this->_caller->request(LOGISTICS_ADDRESS_SEARCH,$params,$callback,$title,$this->_shop['shop_id'],10,false,$addon);
    }

    
    /**
     * 查询地址库回调
     * @param   type    
     * @return  type    description
     * @access  public
     * @author cyyr24@sina.cn
     */
    public function searchAddress_callback($result)
    {
     
        $oAddress = app::get('ome')->model('return_address');
        
        $shop_type = $this->_shop['shop_type'];
        $callback_params = $result->get_callback_params();
        if ($callback_params['shop_id']) {
            $shopModel = app::get(self::_APP_NAME)->model('shop');
            $this->_shop = $shopModel->dump(array('shop_id'=>$callback_params['shop_id']),'shop_id,shop_type');
        }
        $shop_id = $this->_shop['shop_id'];
        $rsp = $result->response;
        if ($rsp['rsp']=='succ') {
            $address_list = json_decode($rsp['data'],true);
             $address_list= $address_list['address_result'];
            //保存至本地
            if ($address_list) {
                $oAddress->db->exec("DELETE FROM sdb_ome_return_address WHERE shop_id='$shop_id'");
                foreach ($address_list as $list ) {
                    $data = array(
                        'cancel_def'    =>$list['cancel_def'],
                        'city'          =>$list['city'],
                        'area_id'       =>$list['area_id'],
                        'phone'         =>$list['phone'],
                        'mobile_phone'  =>$list['mobile_phone'],
                        'province'      =>$list['province'],
                        'addr'          =>$list['addr'],
                        'country'       =>$list['country'],
                        'contact_id'    =>$list['contact_id'],
                        'get_def'       =>$list['get_def'],
                        'contact_name'  =>$list['contact_name'],
                        'seller_company'=>$list['seller_company'],
                        'send_def'      =>$list['send_def'],
                        'zip_code'      =>$list['zip_code'],
                        'shop_type'     =>$this->_shop['shop_type'],
                        'shop_id'       =>$this->_shop['shop_id'],
                    );
                    
                    $rp = $oAddress->save($data);
                    
                }
            }
            
        }
        return $this->_caller->callback($result);
    }

    /**
     * 更新交易收货人信息
     *
     * @param Array $order 订单信息
     * @return void
     * @author 
     **/
    public function update_order_shippinginfo($order)
    { 
        $rs = array('rsp'=>'fail','msg'=>'','data'=>'');
        if (!$order) {
            $rs['msg'] = 'no order';
            return $rs;
        }

        $consignee_area = $order['consignee']['area'];
        if(strpos($consignee_area,":")){
            $t_area            = explode(":",$consignee_area);
            $t_area_1          = explode("/",$t_area[1]);
            $receiver_state    = $t_area_1[0];
            $receiver_city     = $t_area_1[1];
            $receiver_district = $t_area_1[2];
        }

        $params['tid']               = $order['order_bn'];
        $params['receiver_name']     = $order['consignee']['name']?$order['consignee']['name']:'';
        $params['receiver_phone']    = $order['consignee']['telephone']?$order['consignee']['telephone']:'';
        $params['receiver_mobile']   = $order['consignee']['mobile']?$order['consignee']['mobile']:'';
        $params['receiver_state']    = $receiver_state?$receiver_state:'';
        $params['receiver_city']     = $receiver_city?$receiver_city:'';
        $params['receiver_district'] = $receiver_district?$receiver_district:'';
        $params['receiver_address']  = $order['consignee']['addr']?$order['consignee']['addr']:'';
        $params['receiver_zip']      = $order['consignee']['zip']?$order['consignee']['zip']:'';
        
        $callback = array(
            'class' => get_class($this),
            'method' => 'update_order_shippinginfo_callback',
        );

        $title = '店铺('.$this->_shop['name'].')更新[交易收货人信息]:'.$params['receiver_name'].'(订单号:'.$order['order_bn'].')';

        $shop_id = $order['shop_id'];

        $addon['bn'] = $order['order_bn'];

        $this->_caller->request(UPDATE_TRADE_SHIPPING_ADDRESS_RPC,$params,$callback,$title,$shop_id,10,false,$addon);
        
        $rs['rsp'] = 'success';

        return $rs;
    }// TODO TEST

    public function update_order_shippinginfo_callback($result)
    {
        return $this->_caller->callback($result);
    }// TODO TEST

}